<?php
/**
 * Droptables
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 *
 * @package   Droptables
 * @copyright Copyright (C) 2014 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2014 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license   GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC') || die;

/**
 * Class DroptablesViewStyle
 */
class DroptablesViewStyle extends JViewLegacy
{
    /**
     * Display the view
     *
     * @param string $tpl The name of the template file to parse
     *
     * @return void
     */
    public function display($tpl = null)
    {
        $id = JFactory::getApplication()->input->getInt('id');
        $idTable = JFactory::getApplication()->input->getInt('id-table');
        $model = $this->getModel();
        $item = $model->getItem($id);

        require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'droptablesupdate.php');
        $DroptablesUpdate = new DroptablesUpdate();
        $newData = $DroptablesUpdate->updateTable($item);

        $newData['action'] = 'insert';
        require_once(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_droptables' . DIRECTORY_SEPARATOR . 'models' . DIRECTORY_SEPARATOR . 'table.php');
        $DroptablesModelTable = new DroptablesModelTable();

        $DroptablesModelTable->deleteOldStyle($idTable);
//        var_dump($newData);
//        die();

        //add table header = 1
        $newData['params']->headerOption = 1;
        $newData['header_data'] = array($newData['datas'][0]);

        if ($DroptablesModelTable->saveTableSynfile($idTable, $newData)) {
            $dataTable = $DroptablesModelTable->getItem($idTable);
            $dataTable->style = json_encode($dataTable->style);

            $dbo = JFactory::getDbo();
            $droptable_tbl = $dbo->quoteName('#__droptable_tbl_' . $idTable);
            $query = 'ALTER TABLE ' . $droptable_tbl;

            switch ($id) {
                case 1:
                    $dataTable->update_type_columns = array('text','text','text','text','text');
                    $query .= ' MODIFY COLUMN `col1` TEXT, MODIFY COLUMN `col2` TEXT, MODIFY COLUMN `col3` TEXT, MODIFY COLUMN `col4` TEXT, MODIFY COLUMN `col5` TEXT';
                    break;
                case 2:
                    $dataTable->update_type_columns = array('text','text','text','text','text');
                    $query .= ' MODIFY COLUMN `col1` TEXT, MODIFY COLUMN `col2` TEXT, MODIFY COLUMN `col3` TEXT, MODIFY COLUMN `col4` TEXT, MODIFY COLUMN `col5` TEXT';
                    break;
                case 3:
                    $dataTable->update_type_columns = array('varchar','varchar','varchar','varchar','varchar');
                    $query .= ' MODIFY COLUMN `col1` VARCHAR(255), MODIFY COLUMN `col2` VARCHAR(255), MODIFY COLUMN `col3` VARCHAR(255), MODIFY COLUMN `col4` VARCHAR(255), MODIFY COLUMN `col5` VARCHAR(255)';
                    break;
                case 4:
                    $dataTable->update_type_columns = array('text','text','text');
                    $query .= ' MODIFY COLUMN `col1` TEXT, MODIFY COLUMN `col2` TEXT, MODIFY COLUMN `col3` TEXT';
                    break;
                case 5:
                    $dataTable->update_type_columns = array('varchar','varchar','varchar','varchar','varchar','varchar','varchar');
                    $query .= ' MODIFY COLUMN `col1` VARCHAR(255), MODIFY COLUMN `col2` VARCHAR(255), MODIFY COLUMN `col3` VARCHAR(255), MODIFY COLUMN `col4` VARCHAR(255), MODIFY COLUMN `col5` VARCHAR(255), MODIFY COLUMN `col6` VARCHAR(255), MODIFY COLUMN `col7` VARCHAR(255)';
                    break;
                case 6:
                    $dataTable->update_type_columns = array('text','text','text','text');
                    $query .= ' MODIFY COLUMN `col1` TEXT, MODIFY COLUMN `col2` TEXT, MODIFY COLUMN `col3` TEXT, MODIFY COLUMN `col4` TEXT';
                    break;
            }
            $dbo->setQuery($query);
            if ($dbo->execute()) {
                $object = new stdClass();
                $object->params = $newData['params'];
                $object->params->col_types = $dataTable->update_type_columns;
                //"col_types":["varchar","varchar","varchar","int","varchar","varchar","varchar","varchar","varchar","varchar"]
                $object->params = json_encode($object->params);
                $object->id = $idTable;
                $dbo->updateObject('#__droptables_tables', $object, 'id', true);
            }
        } else {
            $dataTable = array('status'=>false);
        }
        header('Content-Type: application/json; charset=utf-8', true);
        echo json_encode($dataTable);
        die();
    }
}
